/* 
 * Example of hierarchical classes and overloading of functions 
 * Created on February 9, 2014, 6:10 PM
 */

#include <cstdlib>
#include <iostream>
#include <string>

using namespace std;

class Living{
protected:
    string genus;
    string species;
public:
    Living() {
    genus = "UNKNOWN";
    species = "SPECIES";
    };
    Living(string g, string s);
    ~Living(){};
    string name() { return genus + " " + species ; };
};

Living::Living(string g, string s) {
    genus = g;
    species = s;
}

class Animal : public Living {
    string voice;
public:
    Animal(): Living() {};    
    Animal(string g, string s): Living(g,s) {};
    Animal(string g, string s, string v): Living(g,s) { voice= v; };
    ~Animal() {
    };
    void setVoice(string a) {
        voice = a;
    };
    string showVoice();
    void setName(string g);
    void setName(string g, string s);
};

void Animal::setName(string g){
    genus = g;
    species = "spec.";
}

void Animal::setName(string g, string s){
    genus = g;
    species = s;
}

string Animal::showVoice() {
    return "The " + genus + " " + species + " says " + voice;
}

int main(int argc, char** argv) {
    
    // initialization
    Animal lion;
    Animal cougar("Puma","concolor");
    Animal leopard;
    Animal tiger("Tigris", "pardalis","ROAR");
    // setting variables after initialziation;
    lion.setVoice("ROARRR");
    leopard.setName("Panthera");
    
    cout << tiger.showVoice() << endl;
    cout << lion.showVoice() << endl;
    cout << cougar.name() << endl;
    cout << leopard.name() << endl;
    return 0;
}

