/* 
 * File:   main.cpp
 * Author: beerli
 * Platonic dice: check out wikipedia about "Platonic Solids"
 * Created on October 18, 2016
 */

#include <cstdlib>
#include <string>
#include <iostream>

using namespace std;

class Platonics {
protected:
  string the_name;
  //Schlaefli symbols (read about these on "platonic solid" in wikipedia)
  long p; // the number of edges of each face (or the number of corners)
  long q; // the number of faces meeting at each corner 
  //(or the number edges meeting at each corner)
public:
  Platonics() {};
  Platonics(string n) {the_name = n; };
  ~Platonics(){};
  void set(long newp, long newq) { p = newp; q=newq; };
  void set(long corners, long edges, long faces);
  long corners() { return 4*p / (4 - (p-2) * (q-2));};
  long faces() { return 4*q / (4 - (p-2) * (q-2));};
  long edges() { return 2*p*q / (4 - (p-2) * (q-2));};
  string schlaefli() { return "{"+to_string(p)+","+to_string(q)+"}";}
  string name() { return the_name; };
  long random() ;
};

void Platonics::set(long corners, long edges, long faces){
  p = 2*edges / faces;
  q = 2*edges / corners;
}

long Platonics::random() {
  // use something like this, but you need to get the faces from the variables 
  // p and q
  // the % delivers the remainder we use the fact that the remainder 
  // with x edges is a number between 0 and x-1, thus adding 1 will 
  // deliver a random number between 1 and x. This allows us to simulate
  // a throw of a polyhedron die. You need to replace FACES with a variable 
  // that is set to the number of faces. 
  long r = myrandom() % FACES + 1;
  return r;
}

class Tetrahedron : public Platonics {
public:
  Tetrahedron() : Platonics() { the_name="Tetrahedron"; set(4,6,4); };
};


int main(int argc, char** argv) {

  srand (time(NULL)); // need to initialize the random number generator
  // example code defining a Tetrahedron and printing out it specifications.
  Tetrahedron t;
  t.set(3,3);
  cout << t.name() << " " << t.schlaefli() << endl;
  cout << t.faces() << endl;
  cout << t.corners() << endl;
  cout << t.edges() << endl;
    
  // write a code that calculates the sum of two dice
  // one is a octahedron and the other an dodecahedron
  // when you throw the combo 1000 times
    
  return 0;
}
