// calculate Pi using Monte Carlo method
// 
#include <iostream>
#include <string>
#include <ctime>
#include <cmath>

//functions
double hypotenuse(double x, double y)
{
  return sqrt(x * x + y * y);
}

double calculate_pi(long n)
{
  long area_circle = 0;
  long area_square = 0;
  double pi=0.0;
  // initialize random number generator
  srandom(time(NULL));
  //   do n times: 
  //      draw random coordinates x,y
  double x = random() / (double) RAND_MAX;
  double y = random() / (double) RAND_MAX;
  //      calculate distance from center of circle
  double d = hypotenuse(x,y);
  //      compare whether we are inside or outside of circle
  //      add 1 to Area_circle
  if (d<1.0)
    {
      area_circle = area_circle + 1;
    }
  //   Area_square = n
  area_square = n;
  //   Calculate Pi as Area_circle/Area_square * 4
  pi = area_circle / area_square * 4;
  return pi;
}



int main(int argc, char **argv)
{
  // how long to run
  long n = std::stol(argv[1]);
  //   calculate Pi
  double pi = calculate_pi(n);
  //   Print result
  std::cout << pi << std::endl;
  //   Compare with real Pi to calculate error  
  return 0;
}
