// calculate Pi using Monte Carlo method
// 
#include <iostream>
#include <string>
#include <ctime>
#include <cmath>

//functions
double hypotenuse(double x, double y)
{
  return sqrt(x * x + y * y);
}

double calculate_pi(long n)
{
  double area_circle = 0.0;
  double area_square = 0.0;
  double pi=0.0;
  double x;
  double y;
  double d;
  // initialize random number generator
  srandom(time(NULL));
  //   do n times:
  for(int i=0; i< n; i++)
    {
      //      draw random coordinates x,y
      x = random() / (double) RAND_MAX;
      y = random() / (double) RAND_MAX;
      //      calculate distance from center of circle
      d = hypotenuse(x,y);
      //      compare whether we are inside or outside of circle
      //      add 1 to Area_circle
      if (d<=1.0)
	{
	  area_circle = area_circle + 1.0;
	}
    }
  //   Area_square = n
  area_square = (double) n;
  //   Calculate Pi as Area_circle/Area_square * 4
  pi = area_circle / area_square * 4.0;
  return pi;
}



int main(int argc, char **argv)
{
  // how long to run
  long n = std::stol(argv[1]);
  //   calculate Pi
  double pi = calculate_pi(n);
  //   Print result
  std::cout << "Pi=" << pi << std::endl;
  //   Compare with real Pi to calculate error  
  double realpi = 3.14159265358979323846264338328;
  std::cout << "Error:" << realpi - pi << std::endl;
  return 0;
}
