// Rational.h holds definitions for our 
// Rational class
//
// (c) Peter Beerli
//

#ifndef RATIONAL_H
#define RATIONAL_H

int gcd(const int p, const int q);

class Rational
{
	private:
		int num; //numerator
		int denom; // denominator
		// reduce() makes sure that we only keep
 		// small numbers.		
		void reduce();

	public:
		Rational(){};
		// initializes a rational number using nominator
		// denominator.
		Rational(int newnom, int newdenom);
		Rational(const Rational& orig);
		~Rational(){};
		void print();
		const Rational & operator=(const Rational &rhs);
		const Rational operator*(const Rational &other);

};

#endif /* RATIONAL_H */
