/* 
 * find the root of a function f(x) using 
 * bisection() and newton()
 */

// more comments needed

#include <iostream>
#include <cstdlib>
#include <cmath>

using namespace std;

double f(double x) {
    return 10.0 * x * x - 3.0 * x;
}

double df(double x)
{
    return 20.0 * x - 3.0;
}

double newton(int n, double a, double tol){
    double fx = f(a);
    double dfx;
    double x = a;
    int count = 0;
    while((fabs(fx) > tol) && (count++ < n)){
        fx = f(x);
        dfx = df(x);
        cout << count << " " << x << " " << fx << endl;
        x = x - fx/dfx;
    }
    return x;
}

double bisection(int n, double a, double b, double tol) {
    double fa = f(a);
    double fb = f(b);
    double c;
    double fc;
    int count = 0;

    while (((b - a) > tol) && (count++ < n)) {
        c = (a + b) / 2.0;
        fc = f(c);
        cout << count << ' ' << a << ' ' << c << ' ' << b << " | " << fa << ' ' << fc << ' ' << fb << endl;
        if (fc < 0.0) {
            if (fa < 0.0) {
                a = c;
                fa = fc;
            } else {
                b = c;
                fb = fc;
            }
        } else {
            if (fa > 0.0) {
                a = c;
                fa = fc;
            } else {
                b = c;
                fb = fc;
            }
        }
    }
    return c;
}

/*
 * main prints out the successive approximation to the root using
 * bisection() and newton()
 */
int main(int argc, char** argv) {
    int n = 100;
    double a = 0.1;
    double b = 0.6;
    double tol = 0.00001;
    cout << "Bisection method:" << endl;
    double x = bisection(n, a, b, tol);
    cout << "x=" << x << endl;
    cout << "Newton method:" << endl;
    x = newton(n,b,tol);
    cout << "x=" << x << endl; 
    return 0;
}

