// a simple square root calculator
// 
// (c) Peter Beerli, Tallahassee, FL 2016
//
//
// This program is interactive when started with no argument. 
// If a argument is given then it will only return the 
// squareroot of the argument (if it is a number)
// Without an argument it will ask for numbers on the terminal.
//
// Syntax: 
//  root 
//  root number
//
// the function and its derivative to solve
#include <iostream>
#include <cmath>


// newton() takes an argument x
double newton(double x0, double a)
{
  // loop until we have a precision of 0.00001
  double x = x0;
  double precision = 0.0001;
  double fx = 10000.0;
  double dfx;
  while (fabs(fx) > precision)
    {
      fx = x*x -a;
      dfx = 2.0 * x;
      //std::cout << fx << " " << dfx << '\n';
      x = x - fx / dfx;
    }
  return x;
}


// start main and evaluate whether there is an argument or not
int main(int argc, char ** argv)
{
  double x0 = 1.0;
  if (argc > 1)
    {
      double a = std::stof(argv[1]);
      double y = newton(x0,a);
      std::cout << "Sqrt(" << a << ")=" << y << std::endl;
      return 0;
    }
  else
    {
      // not yet implemented (see newton3.cpp)
      return 0;
    }
}
 
